/*
 * notamesh by Andrew Tuline + GyverStringOffline_v1.3 by AlexGyver
*/
/////////////////////////////////////////////////////////////////////////////////
///                               Настройка
/////////////////////////////////////////////////////////////////////////////////

#define KOL_LED       144                                  // Сколько светодиодов в гирлянде при первом включении
#define LED_DT        4                                   // Номер пина куда подключена гирлянда
#define POWER_V       5                                    // напряжение блока питания в Вольтах
#define POWER_I       3000                                 // Ток блока питания в милиАмперах
#define GLITER_ON     1                                    // Включить мерание при запуске
#define DEMO_MODE     2                                    // Режим при включении 
                                                          // 0 - последняя запущенная программа
                                                          // 1 - демо режим с последовательным перебором эффектов
                                                          // 2 - демо режим с случайнвым перебором эффектов
#define DEMO_TIME     30                                   // Время отображение эффекта в демо режиме в секундах
#define DIRECT_TIME   30                                   // Через сколько секунд менять направление если 0 - не меняем
#define PALETTE_TIME  15                                   // Через сколько секунд менять палитру если 0 - не меняем
#define LOG_ON        1                                    // Включить лог  1 - включить лог

// **************** НАСТРОЙКИ БЕГУЩЕЙ СТРОКИ ****************
#define BRIGHTNESS 150        // стандартная яркость (0-255)
#define D_TEXT_SPEED 50       // скорость бегущего текста по умолчанию (мс)
#define WIDTH 18              // ширина матрицы
#define HEIGHT 8              // высота матрицы
#define SEGMENTS 1            // диодов в одном "пикселе" (для создания матрицы из кусков ленты)

#define COLOR_ORDER GRB       // порядок цветов на ленте. Если цвет отображается некорректно - меняйте. Начать можно с RGB

#define MATRIX_TYPE 1         // тип матрицы: 0 - зигзаг, 1 - параллельная
#define CONNECTION_ANGLE 1    // угол подключения: 0 - левый нижний, 1 - левый верхний, 2 - правый верхний, 3 - правый нижний
#define STRIP_DIRECTION 0     // направление ленты из угла: 0 - вправо, 1 - вверх, 2 - влево, 3 - вниз
                              // при неправильной настрйоке матрицы вы получите предупреждение "Wrong matrix parameters! Set to default"
                              // шпаргалка по настройке матрицы здесь! https://alexgyver.ru/matrix_guide/
#define COLOR_DEBTH 2         // цветовая глубина: 1, 2, 3 (в байтах)
//#define ORDER_GRB             // ORDER_GRB / ORDER_RGB
#define C_BLACK 0x000000
#define C_GREEN 0x00FF00
#define C_RED 0xFF0000
#define C_BLUE 0x0000FF
#define C_PURPLE 0xFF00FF
#define C_YELLOW 0xFFFF00
#define C_CYAN 0x00FFFF
#define C_WHITE 0xFFFFFF

String text1 = "COVID,";
#define COLOR1 C_RED
String text2 = " УХОДИ ! ";
#define COLOR2 C_GREEN
String text3 = "2020 ";
#define COLOR3 C_RED
String text4 = "С";
#define COLOR4 C_YELLOW
String text5 = "НОВЫМ";
#define COLOR5 C_PURPLE
String text6 = "ГОДОМ ";
#define COLOR6 C_CYAN
String text7 = "2021 ";
#define COLOR7 C_WHITE
String text8 = "";
#define COLOR8 C_WHITE
String text9 = "";
#define COLOR9 C_WHITE
String text10 = "";
#define COLOR10 C_WHITE

#if KOL_LED >255
#error "Kоличество светодиодов в гирлянде не должно превышать 255"
#endif

/*------------------------------------------------------------------------------------------
  --------------------------------------- Начало переменным ---------------------------------
  ------------------------------------------------------------------------------------------*/
#define qsubd(x, b)  ((x>b)?wavebright:0)                     // A digital unsigned subtraction macro. if result <0, then => 0. Otherwise, take on fixed value.
#define qsuba(x, b)  ((x>b)?x-b:0)                            // Unsigned subtraction macro. if result <0, then => 0.

#include "FastLED.h"                                          // https://github.com/FastLED/FastLED
#if FASTLED_VERSION < 3001000
#error "Requires FastLED 3.1 or later; check github for latest code."
#endif
#include "microLED.h"
#include "fonts.h"

// Serial definition
#define SERIAL_BAUDRATE 57600                                 // Or 115200.

// Initialize changeable global variables.
uint8_t max_bright = 255;                                     // Overall brightness definition. It can be changed on the fly.
struct CRGB leds[KOL_LED];                                   // Initialize our LED array. We'll be using less in operation.
CRGBPalette16 gCurrentPalette;                               // Use palettes instead of direct CHSV or CRGB assignments
CRGBPalette16 gTargetPalette;                                // Also support smooth palette transitioning
extern const TProgmemRGBGradientPalettePtr gGradientPalettes[]; // These are for the fixed palettes in gradient_palettes.h
extern const uint8_t gGradientPaletteCount;                     // Total number of fixed palettes to display.
uint8_t gCurrentPaletteNumber = 0;                              // Current palette number from the 'playlist' of color palettes
uint8_t currentPatternIndex = 0;                                // Index number of which pattern is current
TBlendType currentBlending = LINEARBLEND;                     // NOBLEND or LINEARBLEND
uint8_t ledMode = 0;                                          // Starting mode is typically 0. Change INITMODE if you want a different starting mode.
uint8_t demorun = DEMO_MODE;                                          // 0 = regular mode, 1 = demo mode, 2 = shuffle mode.
uint8_t maxMode = 39;                                         // Maximum number of modes.
uint8_t demotime = DEMO_TIME;                                 // Set the length of the demo timer.

// Generic/shared routine variables ----------------------------------------------------------------------
uint8_t allfreq = 32;                                         // You can change the frequency, thus overall width of bars.
uint8_t bgclr = 0;                                            // Generic background colour
uint8_t bgbri = 0;                                            // Generic background brightness
bool    glitter = GLITER_ON;                                  // Glitter flag
uint8_t palchg = 3;                                           // 0=no change, 1=similar, 2=random
uint8_t startindex = 0;
uint8_t thisbeat;                                             // Standard beat
uint8_t thisbright = 0;                                       // Standard brightness
uint8_t thiscutoff = 192;                                     // You can change the cutoff value to display this wave. Lower value = longer wave.
uint16_t thisdelay = 0;                                       // Standard delay
uint8_t thisdiff = 1;                                         // Standard palette jump
int8_t  thisdir = 1;                                          // Standard direction is either -1 or 1. Used as a multiplier rather than boolean.
uint8_t thisfade = 224;                                       // Standard fade rate
uint8_t thishue = 0;                                          // Standard hue
uint8_t thisindex = 0;                                        // Standard palette index
uint8_t thisinc = 1;                                          // Standard incrementer
int     thisphase = 0;                                        // Standard phase change
uint8_t thisrot = 1;                                          // You can change how quickly the hue rotates for this wave. Currently 0.
uint8_t thissat = 255;                                        // Standard saturation
int8_t  thisspeed = 4;                                        // Standard speed change
uint8_t wavebright = 255;                                     // You can change the brightness of the waves/bars rolling across the screen.
long summ = 0;

// for text
uint32_t scrollTimer;
String runningText = "";
boolean loadingFlag, fullTextFlag;
int colorChange[10];
const uint32_t textColors[] PROGMEM = {
  COLOR1,
  COLOR2,
  COLOR3,
  COLOR4,
  COLOR5,
  COLOR6,
  COLOR7,
  COLOR8,
  COLOR9,
  COLOR10,
};

// Display functions -----------------------------------------------------------------------
// Support functions
#include "addglitter.h"

// Display routines
#include "confetti_pal.h"
#include "gradient_palettes.h"
#include "juggle_pal.h"
#include "matrix_pal.h"
#include "noise16_pal.h"
#include "noise8_pal.h"
#include "one_sin_pal.h"
#include "plasma.h"
#include "rainbow_march.h"
#include "rainbow_beat.h"
#include "serendipitous_pal.h"
#include "three_sin_pal.h"
#include "two_sin.h"
#include "blendwave.h"

/*------------------------------------------------------------------------------------------
  --------------------------------------- Start of code --------------------------------------
  ------------------------------------------------------------------------------------------*/
void setup()
{
#if LOG_ON == 1
  Serial.begin(SERIAL_BAUDRATE);                                                  // Setup serial baud rate
  Serial.println(" "); Serial.println("---SETTING UP---");
#endif
  delay(1000);                                                                    // Slow startup so we can re-upload in the case of errors.
  LEDS.setBrightness(max_bright);                                                 // Set the generic maximum brightness value.
  LEDS.addLeds<WS2812B, LED_DT, GRB >(leds, KOL_LED);                             //Для светодиодов WS2812B
  set_max_power_in_volts_and_milliamps(POWER_V, POWER_I);                         //Настройка блока питания
  random16_set_seed(4832);                                                        // Awesome randomizer of awesomeness
  random16_add_entropy(analogRead(2));
  int ranstart = random16();

#if LOG_ON == 1
  Serial.print("Initial strand length: "); Serial.print(KOL_LED); Serial.println(" LEDs");
#endif

  gCurrentPalette = CRGBPalette16(CRGB::Black);
  gTargetPalette = (gGradientPalettes[0]);

  strobe_mode(ledMode, 1);                                                        // Initialize the first sequence

#if LOG_ON == 1
  Serial.println("---SETUP COMPLETE---");
#endif
runningText = String(text1) + text2 + text3 + text4 + text5 + text6 + text7 + text8 + text9 + text10;
  colorChange[0] = stringLength(text1);
  colorChange[1] = colorChange[0] + stringLength(text2);
  colorChange[2] = colorChange[1] + stringLength(text3);
  colorChange[3] = colorChange[2] + stringLength(text4);
  colorChange[4] = colorChange[3] + stringLength(text5);
  colorChange[5] = colorChange[4] + stringLength(text6);
  colorChange[6] = colorChange[5] + stringLength(text7);
  colorChange[7] = colorChange[6] + stringLength(text8);
  colorChange[8] = colorChange[7] + stringLength(text9);
  colorChange[9] = colorChange[8] + stringLength(text10);
} // setup()

//------------------MAIN LOOP---------------------------------------------------------------
void loop()
{
  demo_check();                                                               // If we're in demo mode, check the timer to see if we need to increase the strobe_mode value.
  EVERY_N_MILLISECONDS(50) {                                                  // Smooth palette transitioning runs continuously.
    uint8_t maxChanges = 24;
    nblendPaletteTowardPalette(gCurrentPalette, gTargetPalette, maxChanges);
  }
#if PALETTE_TIME>0
  EVERY_N_SECONDS(PALETTE_TIME) {                                            // If selected, change the target palette to a random one every PALETTE_TIME seconds.
    if (palchg == 3) {
      gCurrentPaletteNumber = addmod8(gCurrentPaletteNumber, 1, gGradientPaletteCount);
    }
    gTargetPalette = gGradientPalettes[gCurrentPaletteNumber];                // We're just ensuring that the gTargetPalette WILL be assigned.
  }
#endif
#if DIRECT_TIME > 0
  EVERY_N_SECONDS(DIRECT_TIME) {                                            // Меняем направление
    thisdir = thisdir * -1;
  }
#endif
  EVERY_N_MILLIS_I(thistimer, thisdelay) {                                    // Sets the original delay time.
    thistimer.setPeriod(thisdelay);                                           // This is how you update the delay value on the fly.
    strobe_mode(ledMode, 0);                                                  // Strobe to display the current sequence, but don't initialize the variables, so mc=0;
  }
  if (glitter) addglitter(10);                                                // If the glitter flag is set, let's add some.
  //fillString(runningText);
  FastLED.show();                                                             // Power managed display of LED's.
} // loop()

//-------------------OTHER ROUTINES----------------------------------------------------------
void strobe_mode(uint8_t newMode, bool mc) {                  // mc stands for 'Mode Change', where mc = 0 is strobe the routine, while mc = 1 is change the routine
  if (mc) {
    fill_solid(leds, KOL_LED, CRGB(0, 0, 0));                // Clean up the array for the first time through. Don't show display though, so you may have a smooth transition.
#if LOG_ON == 1
    Serial.print("Mode: ");
    Serial.println(newMode);
    Serial.println(millis());
#endif
  }
  switch (newMode) {                                          // First time through a new mode, so let's initialize the variables for a given display.
    case  0: if (mc) {
        thisdelay = 10;
      } blendwave(); break;
    case  1: if (mc) {
        thisdelay = 10;
      } fillString(runningText); break;
    case  2: if (mc) {
        thisdelay = 10;
        allfreq = 2;
        thisspeed = 1;
        thatspeed = 2;
        thishue = 0;
        thathue = 128;
        thisdir = 1;
        thisrot = 1;
        thatrot = 1;
        thiscutoff = 128;
        thatcutoff = 192;
      } two_sin(); break;
    case  3: if (mc) {
        thisdelay = 10;
      } rainbow_beat(); break;
    case  4: if (mc) {
        thisdelay = 10;
        palchg = 2;
      } noise8_pal(); break;
    case  5: if (mc) {
        thisdelay = 10;
      } fillString(runningText); break;
    case  6: if (mc) {
        thisdelay = 20;
        allfreq = 10;
        bgclr = 64;
        bgbri = 4;
        thisbright = 255;
        startindex = 64;
        thisinc = 2;
        thiscutoff = 224;
        thisphase = 0;
        thiscutoff = 224;
        thisrot = 0;
        thisspeed = 4;
        wavebright = 255;
      } one_sin_pal(); break;
    case  7: if (mc) {
        thisdelay = 10;
        numdots = 2;
        thisfade = 16;
        thisbeat = 8;
        thisbright = 255;
        thisdiff = 64;
      } juggle_pal(); break;
    case  8: if (mc) {
        thisdelay = 40;
        thisindex = 128;
        thisdir = 1;
        thisrot = 0;
        thisbright = 255;
        bgclr = 200;
        bgbri = 6;
      } matrix_pal(); break;
    case  9: if (mc) {
        thisdelay = 10;
        allfreq = 6;
        thisspeed = 2;
        thatspeed = 3;
        thishue = 96;
        thathue = 224;
        thisdir = 1;
        thisrot = 0;
        thatrot = 0;
        thiscutoff = 64;
        thatcutoff = 64;
      } two_sin(); break;
    case 10: if (mc) {
        thisdelay = 20;
        allfreq = 16;
        bgclr = 0;
        bgbri = 0;
        thisbright = 255;
        startindex = 64;
        thisinc = 2;
        thiscutoff = 224;
        thisphase = 0;
        thiscutoff = 224;
        thisrot = 0;
        thisspeed = 4;
        wavebright = 255;
      } one_sin_pal(); break;
    case 11: if (mc) {
        thisdelay = 50;
        mul1 = 5;
        mul2 = 8;
        mul3 = 7;
      } three_sin_pal(); break;
    case 12: if (mc) {
        thisdelay = 10;
      } serendipitous_pal(); break;
    case 13: if (mc) {
        thisdelay = 20;
        allfreq = 8;
        bgclr = 0;
        bgbri = 4;
        thisbright = 255;
        startindex = 64;
        thisinc = 2;
        thiscutoff = 224;
        thisphase = 0;
        thiscutoff = 224;
        thisrot = 0;
        thisspeed = 4;
        wavebright = 255;
      } one_sin_pal(); break;
    case 14: if (mc) {
        thisdelay = 10;
        allfreq = 20;
        thisspeed = 2;
        thatspeed = -1;
        thishue = 24;
        thathue = 180;
        thisdir = 1;
        thisrot = 0;
        thatrot = 1;
        thiscutoff = 64;
        thatcutoff = 128;
      } two_sin(); break;
    case 15: if (mc) {
        thisdelay = 50;
        thisindex = 64;
        thisdir = -1;
        thisrot = 1;
        thisbright = 255;
        bgclr = 100;
        bgbri = 10;
      } matrix_pal(); break;
    case 16: if (mc) {
        thisdelay = 10;
        palchg = 1;
      } noise8_pal(); break; // By: Andrew Tuline
    case 17: if (mc) {
        thisdelay = 10;
      } plasma(11, 23, 4, 18); break;
    case 18: if (mc) {
        thisdelay = 10;
      } fillString(runningText); break;
    case 19: if (mc) {
        thisdelay = 50;
        mul1 = 6;
        mul2 = 9;
        mul3 = 11;
      } three_sin_pal(); break;
    case 20: if (mc) {
        thisdelay = 10;
        thisdir = 1;
        thisrot = 1;
        thisdiff = 1;
      } rainbow_march(); break;
    case 21: if (mc) {
        thisdelay = 10;
        thisdir = 1;
        thisrot = 2;
        thisdiff = 10;
      } rainbow_march(); break;
    case 22: if (mc) {
        thisdelay = 20;
        hxyinc = random16(1, 15);
        octaves = random16(1, 3);
        hue_octaves = random16(1, 5);
        hue_scale = random16(10, 50);
        x = random16();
        xscale = random16();
        hxy = random16();
        hue_time = random16();
        hue_speed = random16(1, 3);
        x_speed = random16(1, 30);
      } noise16_pal(); break;
    case 23: if (mc) {
        thisdelay = 20;
        allfreq = 6;
        bgclr = 0;
        bgbri = 0;
        thisbright = 255;
        startindex = 64;
        thisinc = 2;
        thiscutoff = 224;
        thisphase = 0;
        thiscutoff = 224;
        thisrot = 0;
        thisspeed = 4;
        wavebright = 255;
      } one_sin_pal(); break;
    case 24: if (mc) {
        thisdelay = 10;
      } plasma(23, 15, 6, 7); break;
    case 25: if (mc) {
        thisdelay = 20;
        thisinc = 1;
        thishue = 192;
        thissat = 255;
        thisfade = 2;
        thisdiff = 32;
        thisbright = 255;
      } confetti_pal(); break;
    case 26: if (mc) {
        thisdelay = 10;
        thisspeed = 2;
        thatspeed = 3;
        thishue = 96;
        thathue = 224;
        thisdir = 1;
        thisrot = 1;
        thatrot = 2;
        thiscutoff = 128;
        thatcutoff = 64;
      } two_sin(); break;
    case 27: if (mc) {
        thisdelay = 30;
        thisindex = 192;
        thisdir = -1;
        thisrot = 0;
        thisbright = 255;
        bgclr = 50;
        bgbri = 0;
      } matrix_pal(); break;
    case 28: if (mc) {
        thisdelay = 20;
        allfreq = 20;
        bgclr = 0;
        bgbri = 0;
        thisbright = 255;
        startindex = 64;
        thisinc = 2;
        thiscutoff = 224;
        thisphase = 0;
        thiscutoff = 224;
        thisrot = 0;
        thisspeed = 4;
        wavebright = 255;
      } one_sin_pal(); break;
    case 29: if (mc) {
        thisdelay = 20;
        thisinc = 2;
        thishue = 128;
        thisfade = 8;
        thisdiff = 64;
        thisbright = 255;
      } confetti_pal(); break;
    case 30: if (mc) {
        thisdelay = 10;
      } plasma(8, 7, 9, 13); break;
    case 31: if (mc) {
        thisdelay = 10;
        numdots = 4;
        thisfade = 32;
        thisbeat = 12;
        thisbright = 255;
        thisdiff = 20;
      } juggle_pal(); break;
    case 32: if (mc) {
        thisdelay = 30;
        allfreq = 4;
        bgclr = 64;
        bgbri = 4;
        thisbright = 255;
        startindex = 64;
        thisinc = 2;
        thiscutoff = 224;
        thisphase = 0;
        thiscutoff = 128;
        thisrot = 1;
        thisspeed = 8;
        wavebright = 255;
      } one_sin_pal(); break;
    case 33: if (mc) {
        thisdelay = 50;
        mul1 = 3;
        mul2 = 4;
        mul3 = 5;
      } three_sin_pal(); break;
    case 34: if (mc) {
        thisdelay = 10;
        thisdir = -1;
        thisrot = 1;
        thisdiff = 5;
      } rainbow_march(); break;
    case 35: if (mc) {
        thisdelay = 10;
      } plasma(11, 17, 20, 23); break;
    case 36: if (mc) {
        thisdelay = 20;
        thisinc = 1;
        thishue = random8(255);
        thisfade = 1;
        thisbright = 255;
      } confetti_pal(); break;
    case 37: if (mc) {
        thisdelay = 10;
      } fillString(runningText); break;
    case 38: if (mc) {
        thisdelay = 10;
        palchg = 0;
      } noise8_pal(); break;
  } // switch newMode
} // strobe_mode()

void demo_check() {
  if (demorun) {                                                  // Is the demo flag set? If so, let's cycle through them.
    uint8_t secondHand = (millis() / 1000) % (maxMode * demotime); // Adjust for total time of the loop, based on total number of available modes.
    static uint8_t lastSecond = 99;                               // Static variable, means it's only defined once. This is our 'debounce' variable.
    if (lastSecond != secondHand) {                               // Debounce to make sure we're not repeating an assignment.
      lastSecond = secondHand;
      if (secondHand % demotime == 0) {                         // Every 10 seconds.
        if (demorun == 2) ledMode = random8(0, maxMode); else {
          ledMode = secondHand / demotime;
        }
        gCurrentPaletteNumber = random8(0, gGradientPaletteCount);
        gTargetPalette = gGradientPalettes[gCurrentPaletteNumber];
        strobe_mode(ledMode, 1);                                // Does NOT reset to 0.
      } // if secondHand
    } // if lastSecond
  } // if demorun
} // demo_check()
